// cssp.h : Declaration of the Ccssp

#ifndef __CSSP_H_
#define __CSSP_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions

/////////////////////////////////////////////////////////////////////////////
// Ccssp
class ATL_NO_VTABLE Ccssp : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<Ccssp, &CLSID_cssp>,
	public IDispatchImpl<Icssp, &IID_Icssp, &LIBID_CSSPDHTMLLib>
{
public:
	Ccssp()
	{ 
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_CSSP)

DECLARE_PROTECT_FINAL_CONSTRUCT()
DECLARE_NOT_AGGREGATABLE(Ccssp)

BEGIN_COM_MAP(Ccssp)
	COM_INTERFACE_ENTRY(Icssp)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// Icssp
public:
	STDMETHOD(Show)(/*[in]*/ BSTR bstrObject, int iBrowser, /*[out,retval]*/ BSTR * pbstrDHTML);
	STDMETHOD(Hide)(/*[in]*/ BSTR bstrObject, int iBrowser, /*[out,retval]*/ BSTR * pbstrDHTML);
	STDMETHOD(MoveTop)(/*[in]*/ BSTR bstrObject, int iBrowser, BSTR bstrValue, /*[out,retval]*/ BSTR * pbstrDHTML);
	STDMETHOD(MoveLeft)(/*[in]*/ BSTR bstrObject, int iBrowser, BSTR bstrValue, /*[out,retval]*/ BSTR * pbstrDHTML);
};

#endif //__CSSP_H_
