// first.h : Declaration of the Cfirst

#ifndef __FIRST_H_
#define __FIRST_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions

/////////////////////////////////////////////////////////////////////////////
// Cfirst
class ATL_NO_VTABLE Cfirst : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<Cfirst, &CLSID_first>,
	public IDispatchImpl<Ifirst, &IID_Ifirst, &LIBID_CPPFIRSTLib>
{
public:
	Cfirst()
	{ 
		m_bOnStartPageCalled = FALSE;
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_FIRST)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cfirst)
	COM_INTERFACE_ENTRY(Ifirst)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// Ifirst
public:
	STDMETHOD(objWriteHeader)();
	//Active Server Pages Methods
	STDMETHOD(OnStartPage)(IUnknown* IUnk);
	STDMETHOD(OnEndPage)();

private:
	CComPtr<IResponse> m_piResponse;				//Response Object
	BOOL m_bOnStartPageCalled;						//OnStartPage successful?
};

#endif //__FIRST_H_
