// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "MTSResponse.h"
#include "mytest.h"
#include <atlbase.h>



/////////////////////////////////////////////////////////////////////////////
// Cmytest

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;

   // get Request property
   bstrObj = "Request";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IRequest, 
                     (void**)&m_piRequest );

   return hr;
} 

BOOL Cmytest::CanBePooled()
{
	return FALSE;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piRequest.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cmytest::expirePage()
{
	HRESULT hr = S_OK;
	SYSTEMTIME stObject;
	DATE dtTime;


    memset( &stObject, 0, sizeof(SYSTEMTIME));
    
	// set day
	stObject.wYear = 1999;
	stObject.wMonth = 7;
	stObject.wDay = 13;

	// set time
	stObject.wHour = 13;
	stObject.wSecond = 13;
	stObject.wMilliseconds = 13;

	SystemTimeToVariantTime(&stObject, &dtTime);
	hr = m_piResponse->put_ExpiresAbsolute(dtTime);

return hr;
}

STDMETHODIMP Cmytest::thetest()
{

   HRESULT hr = S_OK;
   CComPtr<IRequestDictionary> piRequestVariables;
   IUnknown* pUnknown = NULL;
   IWriteCookie* piCookie = NULL;
   IDispatch *piDispatch = NULL;

   DATE   dtObject=36500.0;

   CComVariant vtOut, vtResponse;

   hr = m_piResponse->get_Cookies(&piRequestVariables);

   // if failure, return
   if (FAILED(hr))
     return hr;

   // Get the item from the Contents collection
   CComVariant vtIn(_T("currentval"));
   hr = piRequestVariables->get_Item(vtIn, &vtOut);

  // if failure, return
   if (FAILED(hr)) {
     vtResponse = "Could not get item";
     m_piResponse->Write(vtResponse);
     return hr;
   }

   // get interface to write-only cookie
   piCookie = (IWriteCookie *)V_DISPATCH(&vtOut);

   // if failure, return
   if (FAILED(hr)) {
     vtResponse = "Could not get item";
     m_piResponse->Write(vtResponse);
     return hr;
   }

   // put cookie key-value pair
   CComVariant vtKey(OLESTR("first"));
   CComBSTR bstrValue("23.00");
   
   hr = piCookie->put_Item(vtKey, bstrValue);
   
   // put second cookie key-value pair
   vtKey = "second";
   bstrValue = "35.00";

   hr = piCookie->put_Item(vtKey, bstrValue);

   // set cookie props
   hr = piCookie->put_Expires(dtObject);


   return hr;
}

