import com.ms.com.*;
import com.ms.mtx.*;
import com.ms.asp.*;
import tstjava.*;

/**
 * This class is designed to be packaged with a COM DLL output format.
 * The class has no standard entry points, other than the constructor.
 * Public methods will be exposed as methods on the default COM interface.
 * @com.register ( clsid=9422A7CB-E455-11D2-87CB-204C4F4F5020, typelib=9422A7CC-E455-11D2-87CB-204C4F4F5020 )
 */
public class ObjectContext
{
 public void objTestMTS() {
   
   // new instances of MTS objects
   IObjectContext objContext = null;
   IGetContextProperties objProps = null;
   
   // Response object
   IResponse iObjResponse = null;
   
   // previously created props object
   props_Dispatch prpObject = null;
   
   // variant for using with Response
   Variant v = new Variant();

   // get ObjectContext, Context Properties
   objContext = (IObjectContext) MTx.GetObjectContext();
   objProps = (IGetContextProperties)MTx.GetObjectContext();

   // Get the Response object
   v = objProps.GetProperty("Response");
   iObjResponse = (IResponse)v.getDispatch();
	
	v.VariantClear();
   boolean bResult = false;
		
   try {
      // create instance of test component, call method
      prpObject = (props_Dispatch)objContext.CreateInstance(props.clsid,
                                                            props_Dispatch.iid);
      prpObject.objWriteHeader("From within Component");    
      iObjResponse.Write(v);
      v.VariantClear();

      // test security
      if (objContext.IsSecurityEnabled()) {
         v.putString("Security is enabled <P>");
         iObjResponse.Write(v);
      }
      else {
         v.putString("Security is not enabled <P>");
         iObjResponse.Write(v);
      }
      v.VariantClear();
		
      // test transaction
      if (objContext.IsInTransaction()) {
         v.putString("Component is in transaction ");
         iObjResponse.Write(v);
      }
      else {
         v.putString("Component is not in transaction ");
         iObjResponse.Write(v);
      }
		
      // mark component finished, 
      // successful
      objContext.SetComplete();
      }
      
      // exception handling - mark component finished
      catch(Exception e) {
         bResult = false;
         v.putString(e.getLocalizedMessage());
         iObjResponse.Write(v);
         objContext.SetAbort();
      }
   }
}
