import com.ms.wfc.data.*;
import com.ms.com.*;
import com.ms.mtx.*;
import com.ms.asp.*;
/**
 * This class is designed to be packaged with a COM DLL output format.
 * The class has no standard entry points, other than the constructor.
 * Public methods will be exposed as methods on the default COM interface.
 * @com.register ( clsid=42FF4B84-28BC-11D2-AC2C-204C4F4F5020, typelib=42FF4B85-28BC-11D2-AC2C-204C4F4F5020 )
 */
public class adomts
{
 
    // data members
    // response object
	IResponse iObjResponse = null;
    
    // connection object
    Connection conn = new Connection();
        
    public void make_connection() {
       // waiting...
        IGetContextProperties iObjProps;
        iObjProps = (IGetContextProperties)MTx.GetObjectContext();
        Variant vResponse = new Variant();
        
        // Get the Response object
        vResponse = iObjProps.GetProperty("Response");
        iObjResponse = (IResponse) vResponse.getDispatch();

        Variant vtMessage = new Variant("Waiting for connection...<p>");
       iObjResponse.Write(vtMessage);
        
       		try
		    {

            // create and open connection
            String str = "Provider=SQLOLEDB;DSN=books;database=pubs;Driver={SQL Server}";
            conn.setMode(AdoEnums.ConnectMode.READWRITE);
            conn.setCursorLocation(AdoEnums.CursorLocation.CLIENT);
            conn.open(str,"sa","");      
            vtMessage.putString("Waiting for connection...<p>");
           iObjResponse.Write(vtMessage);
            }
		catch( Exception e )
		    {
		    Variant vtError = new Variant(e.getLocalizedMessage());
		    iObjResponse.Write(vtError);
		    }
            
    }       
    
    public void cleanup() {
        conn.close();
    }
    
    // create connection, response object
	public void test() {
		// access Response object
		String str;
        Variant vtRequest = new Variant();
        IRequest iObjRequest = null;
        IRequestDictionary iObjReqDictionary = null;
        IGetContextProperties iObjProps;
        IObjectContext iObjContext;
        
        iObjContext = (IObjectContext)MTx.GetObjectContext();
        
        iObjProps = (IGetContextProperties)MTx.GetObjectContext();

		try
		{
            // get Request object and form collection

	        vtRequest = iObjProps.GetProperty("Request");
	        iObjRequest = (IRequest)vtRequest.getDispatch();					
	        iObjReqDictionary = iObjRequest.getForm();			
			
	        // get author's last name
	        vtRequest.putString("percentage");
	        vtRequest = iObjReqDictionary.getItem(vtRequest);
            
            // create command
            Command cmd = new Command();
            cmd.setActiveConnection(conn);
            cmd.setCommandType(AdoEnums.CommandType.STOREDPROC);
            cmd.setCommandText("giveraise");
            
            // create parameter
            // create parameter
            Parameters parms = cmd.getParameters();
            Parameter parm = cmd.createParameter("percentage", 
                   AdoEnums.DataType.VARCHAR, AdoEnums.ParameterDirection.INPUT,
                   4, vtRequest.toString());
            
            // append to command parameters
            parms.append(parm);
            
            // execute
            Recordset rs = cmd.execute();
            iObjContext.SetComplete();
            Variant vtOutput = new Variant();

            vtOutput.putString("<h3>Before</H3><table cols=3>");
            iObjResponse.Write(vtOutput);
            
            // process 'before' query
            rs.moveFirst();
            while (!rs.getEOF()) {
                str = rs.getFields().getItem("au_lname").getValue().toString();
                vtOutput.putString("<tr><td>" + str + "</td>");
                iObjResponse.Write(vtOutput);
                str = rs.getFields().getItem("title").getValue().toString();
                vtOutput.putString("<td>" + str + "</td>");
                iObjResponse.Write(vtOutput);
                str = rs.getFields().getItem("royaltyper").getValue().toString();
                vtOutput.putString("<td>" + str + "</td></tr>");
                iObjResponse.Write(vtOutput);                
                rs.moveNext();
                }

            vtOutput.putString("</table>");
            iObjResponse.Write(vtOutput);
            
            
            // discard next value, result of update
            rs = rs.nextRecordset();
            vtOutput.putString("<h3>After</H3><table cols=3>");
            iObjResponse.Write(vtOutput);
            
            // get 'after' results
            rs = rs.nextRecordset();
            rs.moveFirst();
            vtOutput.putString("test");
            iObjResponse.Write(vtOutput);            
            while (!rs.getEOF()) {
                str = rs.getFields().getItem("au_lname").getValue().toString();
                vtOutput.putString("<tr><td>" + str + "</td>");
                iObjResponse.Write(vtOutput);
                str = rs.getFields().getItem("title").getValue().toString();
                vtOutput.putString("<td>" + str + "</td>");
                iObjResponse.Write(vtOutput);
                str = rs.getFields().getItem("royaltyper").getValue().toString();
                vtOutput.putString("<td>" + str + "</td></tr>");
                iObjResponse.Write(vtOutput);                
                rs.moveNext();
                }
            vtOutput.putString("</table>");
            iObjResponse.Write(vtOutput);

            rs.close();
            //end message
            Variant vtMessage = new Variant("Transaction Successful");
            iObjResponse.Write(vtMessage);
            }
        catch (Exception e) {
            Variant vtError = new Variant (e.getMessage());
            iObjResponse.Write(vtError);
        }
    }
    
}