VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Positioning3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const INVALID_BROWSER = 1
' Generate browser-specific string to set left value
Public Function MoveLeft(objid As String, ByVal browser As Integer, _
                         ByVal left As Integer)
    If browser > 1 Or browser < 0 Then
        Err.Raise Number:=INVALID_BROWSER + vbObjectError, Description:="Invalid Browser Number"
    End If
    
    If browser = 1 Then
        MoveLeft = objid + ".style.left=" + CStr(left)
    Else
        MoveLeft = "document." + objid + ".left=" + CStr(left)
    End If
End Function

' Generate browser-specific string to set top value
Public Function MoveTop(objid As String, ByVal browser As Integer, _
                        ByVal top As Integer)
    If browser > 1 Or browser < 0 Then
        Err.Raise Number:=INVALID_BROWSER + vbObjectError, Description:="Invalid Browser Number"
    End If
    
    On Error GoTo HandleError
    
    If browser = 1 Then
        MoveTop = objid + ".style.top=" + CStr(top)
    Else
        MoveTop = "document." + objid + ".top=" + CStr(top)
    End If
HandleError:
    If Err.Number = 11 Then
         ' division by zero
        Err.Raise Number:=Err.Number, Description:="some text"
    End If
End Function

' Generate browser-specific string to set visibility to hidden
Public Function Hide(objid As String, ByVal browser As Integer)
    If browser > 1 Or browser < 0 Then
        Err.Raise Number:=INVALID_BROWSER + vbObjectError, Description:="Invalid Browser Number"
    End If
    
    If browser = 1 Then
        Hide = objid + ".style.visibility='hidden'"
    Else
        Hide = "document." + objid + ".visibility='hidden'"
    End If
End Function

' Generate browser-specific string to set visibility to show
Public Function Show(objid As String, ByVal browser As Integer)
    If browser > 1 Or browser < 0 Then
        Err.Raise Number:=INVALID_BROWSER + vbObjectError, Description:="Invalid Browser Number"
    End If
    
    If browser = 1 Then
        Show = objid + ".style.visibility='inherit'"
    Else
        Show = "document." + objid + ".visibility='inherit'"
    End If
End Function


